#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Core;
using HeuristicLab.Core.Views;
using HeuristicLab.MainForm;

namespace HeuristicLab.ItemTreeViews.Views {
  /// <summary>
  /// The base class for visual representations of items.
  /// </summary>
  [View("ParameterizedNamedItem TreeView")]
  [Content(typeof(ParameterizedNamedItem), false)]
  [Content(typeof(IParameterizedNamedItem), false)]
  public partial class ParameterizedNamedItemTreeView : NamedItemView {
    public new IParameterizedNamedItem Content
    {
      get { return (IParameterizedNamedItem)base.Content; }
      set { base.Content = value; }
    }

    public ParameterizedNamedItemTreeView() {
      InitializeComponent();
    }

    protected override void OnContentChanged() {
      base.OnContentChanged();
      parameterCollectionTreeView.Content = Content == null ? null : Content.Parameters;
    }

    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
      parameterCollectionTreeView.Enabled = Content != null;
    }
  }
}
